#include <cassert>
#include <fstream>

#include "baraja.h"


/* Para usar exit */
#include <stdlib.h>


Baraja::Baraja()
{
	_numCartas = 0;
	_lasCartas = NULL;
}

Baraja::Baraja(const Baraja & b)
{

/*    He comentado estas sentencias


	// Liberar memoria anterior
	if (_lasCartas != NULL)
		delete [] _lasCartas;
*/

	_numCartas = b._numCartas;
	
	_lasCartas = new Carta[_numCartas];
	// TODO: check NULL
	
	for (int i =0; i < _numCartas; i++)
		_lasCartas[i] = b._lasCartas[i];
	
}

Baraja::Baraja(int numCartas)
{
	_numCartas = numCartas;
	_lasCartas = new Carta[numCartas];
	if (_lasCartas == NULL)
		exit(1);	
}

		
Baraja::~Baraja()
{
	if (_numCartas > 0 || _lasCartas != NULL)
	{
	   delete [] _lasCartas;
	   _numCartas = 0;
	   _lasCartas = NULL;
	}
}
		
int Baraja::size(void)
{
   return _numCartas;
}

//--- Operadores ---
Baraja & Baraja::operator=(const Baraja & b)
{
	_numCartas = b._numCartas;
	
	if (_lasCartas != NULL)
		delete [] _lasCartas;	
	
	_lasCartas = new Carta[_numCartas];
	// TODO: check NULL
	
	for (int i =0; i < _numCartas; i++)
		_lasCartas[i] = b._lasCartas[i];	
	
	return *this;
}

Carta & Baraja::operator[](int index)
{
   assert(index >= 0 && index < _numCartas);
	
	return _lasCartas[index];
}


// ---- IO ----
bool Baraja::saveToFile(char * filename)
{
	ofstream f(filename);
	assert(f);
		
	for (int i = 0; i < size(); i++)
	{
		Carta c;
		c = _lasCartas[i];
		
		f << c.getPalo() << " " << c.getNumero() << endl;
	}
	
	f.close();
	return true;
}

bool Baraja::loadFromFile(char * filename)
{
	ifstream f(filename);	
	assert(f);
	
	Carta c;
	int n=0;
	string palo;
	int numero;
	
	// Cuenta cartas
	while(!f.eof())
	{
		f >> palo;
		f >> numero;
		if (!f.eof())
			n++;
	}
	
	f.close();
	
	// Load data
	f.open(filename);
	
	if (_lasCartas != NULL)
		delete [] _lasCartas;
	
	_numCartas = n;
	_lasCartas = new Carta[n];
	
	for (int i = 0; i < n; i++)
	{
		
		f >> palo;
		f >> numero;
		c.setNumero(numero);
		c.setPalo(palo);
		
		_lasCartas[i] = c;
	}
	
	f.close();
	return true;
}
