#include <cassert>
#include <fstream>

#include "barajaSTL.h"


BarajaSTL::BarajaSTL()
{
	;	
}

BarajaSTL::BarajaSTL(const BarajaSTL & b)
{
	// Liberar memoria anterior
	if (_lasCartas.size() > 0)
		_lasCartas.clear();
		
	_lasCartas = vector<Carta>(b._lasCartas);
	// TODO: check NULL
	/*
	for (int i =0; i < b.size(); i++)
		_lasCartas[i] = b._lasCartas[i];
	*/
}

BarajaSTL::BarajaSTL(int numCartas)
{	
	_lasCartas = vector<Carta>(numCartas);

}
		
BarajaSTL::~BarajaSTL()
{
	if (_lasCartas.size() > 0)
	{
	   _lasCartas.clear();
	   //_numCartas = 0;
		//_lasCartas = NULL;
	}
}
		
int BarajaSTL::size(void)
{
   return _lasCartas.size();
}

//--- Operadores ---
BarajaSTL & BarajaSTL::operator=(const BarajaSTL & b)
{
	//_numCartas = b._numCartas;
	
	if (_lasCartas.size() > 0)
		_lasCartas.clear();	
	
	_lasCartas = vector<Carta>(b._lasCartas);
	// TODO: check NULL
	/*
	for (int i =0; i < b.size(); i++)
		_lasCartas[i] = b._lasCartas[i];	
	*/
		
	return *this;
}

Carta & BarajaSTL::operator[](int index)
{
   assert( (index >= 0) && (index < (signed) _lasCartas.size()));
	
	return _lasCartas[index];
}


// ---- IO ----
bool BarajaSTL::saveToFile(char * filename)
{
	ofstream f(filename);
	assert(f);
	
	for (int i = 0; i < size(); i++)
	{
		Carta c;
		c = _lasCartas[i];
		
		f << c.getPalo() << " " << c.getNumero() << endl;
	}
	
	f.close();
	return true;
}

bool BarajaSTL::loadFromFile(char * filename)
{
	ifstream f(filename);	
	assert(f);
	
	Carta c;
	int n=0;
	string palo;
	int numero;
	
	// Cuenta cartas
	while(!f.eof())
	{
		f >> palo;
		f >> numero;
		if (!f.eof())
			n++;
	}
	
	f.close();
	
	// Load data
	f.open(filename);
	
	if (_lasCartas.size() > 0)
		_lasCartas.clear();
	
	//_numCartas = n;
	_lasCartas = vector<Carta>(n);
	
	for (int i = 0; i < n; i++)
	{
		
		f >> palo;
		f >> numero;
		c.setNumero(numero);
		c.setPalo(palo);
		
		_lasCartas[i] = c;
	}
	
	f.close();
	return true;
}
