// Test de clase Baraja
// (c) mjmarin/2010

#include "baraja.h"

#include <cassert>
#include <iostream>
#include <fstream>
#include <string>


/* Para usar exit */
#include <stdlib.h>

using namespace std;

void findString(string filePath,string cad,string msg)
{
	ifstream file(filePath.c_str());
	assert(file);
	string str;
	while(!file.eof()){
		file>>str;
		if (str.find(cad) != string::npos) return;
	}
	cout<<"ERROR: "<<msg<<endl;
	exit( 0 );
}

int main(void)
{
	int N = 10;
	Baraja b1, b2(N);	
	Carta c1;
	
	assert(b1.size() == 0);
	assert(b2.size() == N);

	cout << " - Carta en b2 " << b2[0] << endl;

	for (int i = 0; i < b2.size(); i++)
	{
		b2[i].setPalo("Copas");
		b2[i].setNumero(i);
	}


	Baraja b3(b2);

	assert(b2[1] == b3[1]);

	Baraja b4(N/2);
	b4 = b2;
	
	assert(b4.size() == b2.size());
		
	findString("baraja.h","#ifndef","La clase debe estar definida con #ifndef");
	findString("baraja.h","#define","La clase debe estar definida con #define");
	
	findString("baraja.cpp","new","La reserva de memoria debe hacerse con new");
	findString("baraja.cpp","delete","La liberacion de memoria debe hacerse con delete");
	findString("baraja.cpp","~Baraja","Debe existir el destructor");
	
	cout << endl <<"$$$$$$$$$$$$$$ Test superado. "<<endl;
}
