// Test de clase Baraja. Manejo de ficheros
// (c) mjmarin/2010

#include "baraja.h"

#include <cassert>
#include <iostream>
#include <fstream>
#include <string>


/* Para usar exit */
#include <stdlib.h>

using namespace std;

void findString(string filePath,string cad,string msg)
{
	ifstream file(filePath.c_str());
	assert(file);
	string str;
	while(!file.eof()){
		file>>str;
		if (str.find(cad) != string::npos) return;
	}
	cout<<"ERROR: "<<msg<<endl;
	exit( 0 );
}

int main(void)
{
	int N = 10;
	Baraja b1, b2(N);	
			

	for (int i = 0; i < b2.size()/2; i++)
	{
		b2[i].setPalo("Copas");
		b2[i].setNumero(i+1);
	}
	
	for (int i = 0; i < b2.size()/2; i++)
	{
		b2[i+N/2].setPalo("Oros");
		b2[i+N/2].setNumero(i+1);
	}	
	
	b2.saveToFile((char *)"unaBaraja.txt");
	
	b1.loadFromFile((char *)"unaBaraja.txt");
	
	cout << " - Carta en b1: " << b1[b1.size()-1] << endl;
	
	assert(b2[b2.size()-1] == b1[b1.size()-1]);
		
	findString("baraja.cpp","fstream","Debe manejar ficheros con fstream");
	findString("baraja.cpp","close","Debe cerrar los ficheros al terminar");	
	
	cout << endl <<"$$$$$$$$$$$$$$ Test superado. "<<endl;
}
