// Test de clase BarajaSTL. 
// (c) mjmarin/2010

#include "barajaSTL.h"

#include <cassert>
#include <iostream>
#include <fstream>
#include <string>

/* Para usar exit */
#include <stdlib.h>


using namespace std;

void findString(string filePath,string cad,string msg)
{
	ifstream file(filePath.c_str());
	assert(file);
	string str;
	while(!file.eof()){
		file>>str;
		if (str.find(cad) != string::npos) return;
	}
	cout<<"ERROR: "<<msg<<endl;
	exit( 0 );
}

int main(void)
{
	int N = 16;
	BarajaSTL b1, b2(N);	
			

	for (int i = 0; i < b2.size()/2; i++)
	{
		b2[i].setPalo("Espadas");
		b2[i].setNumero(i+1);
	}
	
	for (int i = 0; i < b2.size()/2; i++)
	{
		b2[i+N/2].setPalo("Bastos");
		b2[i+N/2].setNumero(i+1);
	}	
	
	BarajaSTL b3(1);
	b3 = b2;
	assert(b3.size() == b2.size());
	
	b2.saveToFile((char *)"unaBarajaSTL.txt");
	
	b1.loadFromFile((char *)"unaBarajaSTL.txt");
	
	cout << " - Carta en b1: " << b1[b1.size()-1] << endl;
	
	assert(b2[b2.size()-1] == b1[b1.size()-1]);
		
	findString("barajaSTL.cpp","vector<","Debe hacer uso de la clase vector STL");
	findString("barajaSTL.cpp","~BarajaSTL","Debe existir el destructor");
	findString("barajaSTL.cpp","operator","Debe incluir los operadores de Baraja");
	
	cout << endl <<"$$$$$$$$$$$$$$ Test superado. "<<endl;
}
